/* AVR32 AT32AP7000(NGW100) p u[gAbvW[
   STK1000/SDRAM application noteC.  @@myan
*/

#define MODE_NORMAL		0
#define MODE_NOP		1
#define MODE_PRECHARGE		2
#define MODE_LOAD_MR		3
#define MODE_AUTOREFRESH	4
#define MODE_EXT_LOAD_MR	5
#define MODE_POWER_DOWN		6

  .section  .reset, "ax", @progbits

  .global _start
  .type _start, @function
_start:
  // KŏTOTAL CYCLE珑
  mov r0,0x340C
  orh r0,0xfff0
  mov r2,0x0007
  orh r2,0x0007
  st.w --r0,r2
  mov r2,0x0504
  orh r2,0x0503
  st.w --r0,r2
  mov r2,0x0002
  orh r2,0x0002
  st.w --r0,r2
  // PLL x6ݒɂ(20MHz*6=120MHz)
  // PLL CTRL
  // PLLMUL=6 (5+1),PLLDIV=1(0+1),PLLEN=1,PLLOSC=OSC0
  mov r2,0x0011
  orh r2,0x0005
  mov r0,0x20
  orh r0,0xfff0
  st.w r0,r2
  // PLL0Lock܂ő҂ ISR
  mov r0,0x4c
  orh r0,0xfff0
_WAITPLL0LOCKED:
  ld.w r2,r0
  andl r2,1
  breq _WAITPLL0LOCKED
  // CKSEL
  // HSB 60MHz,PBA 30MHz,PBB 60MHz,CPU 120MHz
  mov r2,0x8000
  orh r2,0x8081
  mov r0,4
  orh r0,0xfff0
  st.w r0,r2
  // CKSEL؂ւő҂ ISR
  mov r0,0x4c
  orh r0,0xfff0
_WAITCKSEL:
  ld.w r2,r0
  andl r2,0x20
  breq _WAITCKSEL
  // MCCTRL
  mov r0,0
  orh r0,0xfff0
  mov r2,0x02
  st.w r0,r2
  // ƃSDRAMāAC̃X^[gAbv܂
  // ͂ˏグĩfoCX̐ݒC/C++̂Ƃŏ)
  // RAM΁AƂ͂ǂɂłȂ̂ł
  // HMATRIX SFR4ݒ(CS1/SDRAMݒ,pullup off)
  // Rp(R0~R15),RsRd(R0,R2..R14)̐ɒ
    mov   r0,0x0920
    orh   r0,0xfff0
    ld.w  r2,r0[0]
    orl	  r2,0x102
    st.w  r0[0],r2
  //
  // STK1000ł32bit SDRAMȂ̂PIOE̐ݒĂ邪ANGW
  // 16bit SDRAMȂ̂ŕsvB
  //
  // SDRAM DATASHEETɏ菇Ă̂łQl:)
  // Micron MT48LC16M16A2p̐ݒ (@60MHz:16.66666ns)
  // 16bit bus,column = 9@row = 13@ bank =4 Cas latency = 2
  // tWR = 2clk tRC = 60ns (4clk) PRECHARGEŏTCN = 15ns (1clk)
  // tRCD = 15ns (1clk) rRAS = 37ns (3clk) tXSR = 67ns (4clk)
  //    43 / 11 / 42 / d9(1,10,1,10,01)
  // r0=sdramc.cr
    mov   r0,0x3808
    orh   r0,0xfff0
    mov	  r2,0x42d9
    orh	  r2,0x4311
    st.w  r0[0],r2
  // 200usEFCg
    mov	  r0,12000
_WAITLOOP:
    sub	  r0,1
    brne  _WAITLOOP
  // SoNvW[Ws
  // r0=sdramc.mr
  // r1=sdram address (0xb0000000)
    mov   r0,0x3800
    orh   r0,0xfff0
    eor	  r1,r1
	orh   r1,0xb000
  //
	mov   r2,MODE_PRECHARGE
	st.w  r0[0],r2
	ld.w  r2,r0
    eor	  r2,r2
	st.w  r1[0],r2
  // I[gtbVWs
    mov	  r2,MODE_AUTOREFRESH
    st.w  r0[0],r2
    ld.w  r2,r0
    eor	  r2,r2
    mov	  r3,8
_AUTOREFLOOP:
    st.h  r1[0],r2
    sub	r3,1
    brne  _AUTOREFLOOP
	// SDRAMRAM̒ɂ郂[hWX^ݒ肷
	// CeV2Ao[XgPAV[PV]
    mov   r2,MODE_LOAD_MR
	st.w  r0[0],r2
	ld.w  r2,r0
	// CONFIGRATION Burst = 1,CAS Latency=2
	// A0~4,6~10=0 A5=1
	orl	  r1,0x0080
	eor	  r2,r2
	st.h  r1[0],r2
	ld.w  r2,r0
	// ʏ퓮Ԃ֖߂
	mov	  r2,MODE_NORMAL
	st.w  r0[0],r2
	ld.w  r2,r0
	andl  r1,0x0000
	eor	  r2,r2
	st.h  r1[0],r2
	// tbVTCN̊Ԋuݒ肷
    // REF = 64ms / 8192 = 15.6 uS = 15600 ns.
    // @60MHz = 16.666 ns
    // Refresh rate = 15600 ns / 16.666 ns = 936 clock cycles
    mov   r0,0x3804
    orh   r0,0xfff0
	mov	  r2,936
	st.w  r0[0],r2
	// 0xa000xxxx  0x0000xxxx̋ԂփWv
    lda.w   pc, _stext

